
  #portions of this code are modifications of examples from Google
  # Copyright 2005-2007, Google, Inc.
  # V2.0

 
 require 'sketchup.rb'




#creates dado in component face
 class MortiseTool #*****************************************************************
   #@status=0 start,  =1 select component, =2 first edge, =3 second edge
   
   @@todist=nil   #make class variables persist
   @@toedge=nil
   @@depth=nil  
   @@width=nil
   @@length=nil
   @@ed2toend=nil   

  def initialize
   @entity=nil
   @ss=nil
   @status=0
   @inpt=nil
   @tinpt=nil
   @ip=nil
   if !@@todist then @@todist=0.25.inch end           #defaults
   if !@@toedge then @@toedge="Square" end
   if !@@depth then @@depth=0.875.inch end                  
   if !@@width then @@width=0.25.inch end
   if !@@length then @@length=3.00.inch end
   if !@@ed2toend then @@ed2toend=0.5.inch end

  end

  #is called when first activated
  def activate
   @inpt = Sketchup::InputPoint.new           #set up Input point and temp and diplayed
   @tinpt= Sketchup::InputPoint.new
   @ip= Sketchup::InputPoint.new
   #@displayed = false

   #lets see if any componenent is already selected
   model=Sketchup.active_model
   @ss=model.selection
   le=@ss.count   

   self.reset(nil)
  
   @status=0
   oops=0
   if le==1
    @entity=@ss.first
    type=@entity.typename
    if type=="ComponentInstance"
     if @@tooltype=="Tenon"
          Sketchup::set_status_text "Select First Edge in component Parallel to Tenon Width",SB_PROMPT
          @status=2
        else
          Sketchup::set_status_text "Select First Edge in component Parallel to Mortise Length",SB_PROMPT
          @status=2
        end
    else
     oops=1
    end
   elsif le>=1
    oops=1
   else                      #nothing selected
    @status=1
   end
   
   if oops==1
    UI.messagebox "Selection invalid"
    @ss.clear
    @entity=nil
    @status=1
   end
  end
  
  #is called if tool is deactivated because a different tool is selected
  def deactivate(view)
   view.invalidate 
  end

  #onCancel is called when user hits escape etc
  def onCancel(flag, view)
    if (flag==2)
     view.invalidate
    else
     self.reset(view)
    end
  end

 #reset to start over again
  def reset(view)
   @status=1
   @displayed=false
   @entity=nil
     Sketchup::set_status_text "Select component",SB_PROMPT
  end

   #cruise for a point in component
  def onMouseMove(flags, x, y, view)
   if (@status==2 or @status==3)
    @tinpt.pick view, x, y
    if (@tinpt.valid?) 
      changed=@tinpt != @inpt
      @inpt.copy! @tinpt 
      view.tooltip = @tinpt.tooltip
      #display point
      if ( changed and (@inpt.display? or @displayed))
       view.invalidate 
      end
    end
   end
  end

  #get a point
  def onLButtonDown(flags, x, y, view)
    if @status==1  #select component*************
     ph=view.pick_helper
     ph.do_pick x,y
     @entity=ph.best_picked
     if @entity
      type=@entity.typename
      if type=="ComponentInstance"
       model=Sketchup.active_model
       @ss=model.selection
       @ss.add(@entity)
        if @@tooltype=="Tenon"
          Sketchup::set_status_text "Select First Edge in component Parallel to Tenon Width",SB_PROMPT
          @status=2
        else
          Sketchup::set_status_text "Select First Edge in component Parallel to Mortise Length",SB_PROMPT
          @status=2
        end
      else
       UI.messagebox "Selection invalid"
      end
     end
    elsif @status==2
	 @ip.pick view,x,y
	 oops=1
     if(@ip.valid?)
	  if(@ip.edge)
	   if (@entity.definition==@ip.edge.parent)
	    if ((!@ip.vertex) and (@ip.depth>0))
		 oops=0
		 @edge1=@ip.edge
	     Sketchup::set_status_text "Select Second Edge in component Parallel to First Edge",SB_PROMPT
         @status=3
		end 
	   end	
	  end 
	 end
	 if oops==1
	  @status=2
	  @edge1=nil
	  UI.messagebox "Invalid point"
	 end
	elsif @status==3
	 @ip.pick view,x,y
     oops=1
     if(@ip.valid?)
	  if(@ip.edge)
	   if (@entity.definition==@ip.edge.parent)
	    if ((!@ip.vertex) and !(@ip.edge==@edge1) and (@ip.depth>0))
		 oops=0
		 Sketchup.active_model.start_operation "undo"
		 @edge2=@ip.edge
		 #collectentities
            componentdefinition=@entity.definition
            allent=componentdefinition.entities
            #collect face entities
            faceent=[]
            allent.each do |ent|
             if ent.typename=="Face"
              faceent << ent
             end
            end
		    #find face that has edges 1 and 2
			face=@edge1.common_face @edge2
			if (face==nil)                    #get valid face
		     oops=1
			else                              #got valid face######################
			   #get points in local coord system for face
			   #xaxis parallel to @edge1
			   orig=@edge1.start
               x,y,z=face.normal.axes
			   #get vector parallel to @edge1
			   p1=@edge1.start.position
			   p2=@edge1.end.position
			   ar=[p2.x-p1.x,p2.y-p1.y,p2.z-p1.z]
			   xx=ar.normalize
			   yy=z.cross xx
               localt=Geom::Transformation.axes(orig,xx,yy,z).invert!
			   backt=Geom::Transformation.axes(orig,xx,yy,z)
			   edges=face.outer_loop.edges
			   eind=edges.index(@edge1)
			   if @@width<0.001 
			       #Reset width to pos no!!!
             @@width=-1*@@width
         end
         #Select prompt based on which tool was called Mortise or Tenon
         if @@tooltype=="Tenon"
			     prompts = ["Edge1 to Width","End Shape", "Thickness","Length","Width","Edge to End"]

               defaults= [@@todist,@@toedge,@@width,@@depth,@@length,@@ed2toend]
               
               choices = ["","Square|Round","",""]
   
               results = inputbox prompts, defaults, choices, "Add Tenon"
         else
         
			     prompts = ["Edge1 to Length","End Shape", "Width","Depth","Mortise Length","Edge to End"]

               defaults= [@@todist,@@toedge,@@width,@@depth,@@length,@@ed2toend]
               
               choices = ["","Square|Round","",""]
   
               results = inputbox prompts, defaults, choices, "Add Mortise"
         end 
               #return if not results
			   if not results  #user cancel
			    @status=2
			    @edge1=nil
			    @edge2=nil
			    return
			   end
  
               @@todist=results[0]
               @@toedge=results[1]
               @@width=results[2]
               @@depth=results[3]
               @@length=results[4]
               @@ed2toend=results[5]
               
 			   
			   if @@toedge=="Square"
			     ofstov=@@todist+@@width
			     r=0.0
			   else @@toedge=="Round"
			     ofstov=@@todist+@@width
			     r=0.5*@@width
			     @@length=@@length-(2*r)
			     #57.29578
			     dely30=r*0.866
			     delx30=r*0.5
			     dely60=r*0.5
			     delx60=r*0.866
			   end
			   ofstto=ofstov-@@width
			   p3=@edge2.start.position.transform(localt)
			   en=eind-edges.length+1;i=eind-1
			   dir=p3.y<=>0 
			   ofstov=dir*ofstov
			   ofstto=dir*ofstto
			   frstov=0
			   frstto=0
			   while i>=en
			    p1=edges[i].start.position.transform(localt)
                p2=edges[i].end.position.transform(localt)
                p1y=p1.y;p2y=p2.y
				if p1y>p2y then p1y,p2y=p2y,p1y end
                if (p1y..p2y)===ofstov
				 x=p1.x+(ofstov-p1.y)/(p2.y-p1.y)*(p2.x-p1.x)
				 if frstov==0 then x1=x;frstov=1 end
				 x2=x
                end	
				if ofstto.abs>0.001
				 if (p1y..p2y)===ofstto
				  x=p1.x+(ofstto-p1.y)/(p2.y-p1.y)*(p2.x-p1.x)
				  if frstto==0 then x4=x;frstto=1 end
				  x3=x
				 end
				end
			    i-=1
			   end
        
         #This IF statement always puts the mortise inside the board end
			   if x1>x2
			     delx_dir=1
			     dely_dir=1
			     x1=x1-(@@ed2toend+r)
			     x2=x1-(@@length )
			     x3=x2
			     x4=x1		     
			   else
			     delx_dir=2
			     x1=x1+(@@ed2toend+r)
			     x2=x1+(@@length )
			     x3=x2
			     x4=x1
			   end
			   pt1=Geom::Point3d.new(x1,ofstov,0)
			   pt2=Geom::Point3d.new(x2,ofstov,0)		   
			   pt4=Geom::Point3d.new(x4,ofstto,0)
			   pt3=Geom::Point3d.new(x3,ofstto,0)

			   po1=pt1.transform(backt)
			   po4=pt4.transform(backt)
			   po2=pt2.transform(backt)
			   po3=pt3.transform(backt)
			   			   
			   codef=@entity.definition
			   
			   if @@toedge=="Round"   #Points for top and bottom arc
			     if delx_dir==2
			       dely_dir=-1
			       delx30=-1*delx30
			       delx60=-1*delx60
			       r=-1*r
			       @@width=-1*@@width
			     end
			     #UI.messagebox "Start calculating pt2a to pt4e"			     
			     pt2a=Geom::Point3d.new(x2-delx30,ofstov+(@@width/2)-(dely30*dely_dir),0)
			     pt2b=Geom::Point3d.new(x2-delx60,ofstov+(@@width/2)-(dely60*dely_dir),0)
			     pt2c=Geom::Point3d.new(x2-r,ofstov+(@@width/2),0)
			     pt2d=Geom::Point3d.new(x2-delx60,ofstov+(@@width/2)+(dely60*dely_dir),0)
			     pt2e=Geom::Point3d.new(x2-delx30,ofstov+(@@width/2)+(dely30*dely_dir),0)
			       
			     pt4a=Geom::Point3d.new(x4+delx30,ofstto-(@@width/2)+(dely30*dely_dir),0)
			     pt4b=Geom::Point3d.new(x4+delx60,ofstto-(@@width/2)+(dely60*dely_dir),0)
			     pt4c=Geom::Point3d.new(x4+r,ofstto-(@@width/2),0)
			     pt4d=Geom::Point3d.new(x4+delx60,ofstto-(@@width/2)-(dely60*dely_dir),0)
			     pt4e=Geom::Point3d.new(x4+delx30,ofstto-(@@width/2)-(dely30*dely_dir),0)
			     #UI.messagebox "End calculating pt2a to pt4e"
			     
           po2a=pt2a.transform(backt)
           po2b=pt2b.transform(backt)
           po2c=pt2c.transform(backt)
           po2d=pt2d.transform(backt)
           po2e=pt2e.transform(backt)
           po4a=pt4a.transform(backt)
           po4b=pt4b.transform(backt)
           po4c=pt4c.transform(backt)
           po4d=pt4d.transform(backt)
           po4e=pt4e.transform(backt)
           #UI.messagebox "Completed Transforming  pt2a to pt4e"			   
			   end
			   
			   if @@toedge=="Round"
			     #UI.messagebox "Add cface for round ends here"
			     @@length=@@length+(2*r)  #Resets Length to origional Data
			     cface=codef.entities.add_face po1,po2,po2a,po2b,po2c,po2d,po2e,po3,po4,po4a,po4b,po4c,po4d,po4e
           #cface=codef.entities.add_face po1,po1e,po1c,po4,po3,po3c,po2
			   else
           #UI.messagebox "Add cface for square ends here"
			     cface=codef.entities.add_face po1,po4,po3,po2
			   end
			   if @@tooltype=="Tenon"
			     h=@@depth
			   else
		       h=-1*@@depth
         end	   
         cface.pushpull h
         Sketchup.active_model.commit_operation
         
			   #This Mortise is Complete ask user for edge to start again          
		     if @@tooltype=="Tenon"
          Sketchup::set_status_text "Select First Edge in component Parallel to Tenon Width",SB_PROMPT
          @status=2
        else
          Sketchup::set_status_text "Select First Edge in component Parallel to Mortise Length",SB_PROMPT
          @status=2
        end
		    end                                ####################################
		end 
	   end	
	  end 
	 end
     if oops==1
	  @status=3
	  @edge2=nil
	  UI.messagebox "Invalid point"
	 end	  
    end
  end  

  #draw is called when we want to display then point
  def draw(view)
   if( @inpt.valid? and @inpt.display? )
    @inpt.draw view
    @displayed=true
   else
    @displayed=false
   end
  end

  
 end #end Class MortiseTool*********************************************

 #function acts as short cut for selecting tool
 def addtenon
   @@tooltype="Tenon"
   Sketchup.active_model.select_tool MortiseTool.new
 end

 #function acts as short cut for selecting tool
 def mortiseboard
   @@tooltype="Mortise"
   Sketchup.active_model.select_tool MortiseTool.new
 end 
 #add to Draw menu after separator

 
 if( not file_loaded?("MortiseTool.rb"))
  #add_separator_to_menu("Draw")
#  UI.menu("Draw").add_separator
  UI.menu("Draw").add_item("Mortise"){mortiseboard}
  UI.menu("Draw").add_item("Tenon"){addtenon}
 end

 file_loaded("MortiseTool.rb")
#--------------------------------------
